/**
 * @author Leinarion for www.phileasson-projekt.de
 * @file GUI.java
 * 
 */

import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.DefaultTableModel;


public class GUI extends JFrame{
	
	private JPanel jContentPane = null;
	private JTextField jNumberOfRolls = null;
	private JTextField jTimes = null;
	private JTextField jNumberOfDice = null;
	private JTextField  jWField= null;
	private JTextField jNumberOfFaces = null;
	private JTextField jPlus = null;
	private JTextField jModification = null;
	private JButton button = null;
	private JTextField jResult = null;
	private JScrollPane jScrollPane = null;
	private JTable jTable = null;
	private JPanel jOperationPanel = null;
	private JPanel jDicePanel = null;
	private JTextField jLog = null;
	
	private DSAKalteMain main;
	
	
	private String[] names = new String[main.NOOFFIGHTERS]; //bad style. need to get thisNOOFFIGHTERS from DSAKAlteMain, when importing Players to initialize the JTable with the correct size.
	

	public GUI(){
		super();
		initialize();
		
	}
	
	public void initialize(){
		this.setSize(325,130);
		this.setContentPane(getJContentPane());
		this.setTitle("DSA-Klterechner");
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
	}

	private JPanel getJContentPane(){
		if(jContentPane == null){
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridLayout());
			jContentPane.add(getJScrollPane());
			jContentPane.add(getJOperationPanel());
		}
		return jContentPane;
	}
	private JPanel getJOperationPanel(){
		if(jOperationPanel == null){
			jOperationPanel = new JPanel();
			jOperationPanel.setLayout(new GridLayout(4,1)); 
			jOperationPanel.add(getJDicePanel());
			jOperationPanel.add(getButton());
			jOperationPanel.add(getJResult());
			jOperationPanel.add(getJLog());
		}
		return jOperationPanel;
	}
	private JPanel getJDicePanel(){
		if(jDicePanel == null){
			jDicePanel = new JPanel();
			jDicePanel.setLayout(new GridLayout(1,7));
			jDicePanel.add(getJNumberOfRolls());
			jDicePanel.add(getJTimes());
			jDicePanel.add(getJNumberOfDice());
			jDicePanel.add(getJWField());
			jDicePanel.add(getJNumberOfFaces());
			jDicePanel.add(getJPlus());
			jDicePanel.add(getJModification());
			
		}
		return jDicePanel;
	}
	// A few textfields the specify the amount of damage. Some of them are not editable.
	
	private JTextField getJNumberOfRolls(){
		if(jNumberOfRolls == null){
			jNumberOfRolls = new JTextField("2");
			jNumberOfRolls.setEditable(true);
			jNumberOfRolls.setPreferredSize(new Dimension(20,20));
		}
		return jNumberOfRolls;
	}
	private JTextField getJTimes(){
		if(jTimes == null){
			jTimes = new JTextField("*");
			jTimes.setEditable(false);
			jTimes.setPreferredSize(new Dimension(20,20));
		}
		return jTimes;
	}
	private JTextField getJNumberOfDice(){
		if(jNumberOfDice == null){
			jNumberOfDice = new JTextField("2");
			jNumberOfDice.setEditable(true);
			jNumberOfDice.setPreferredSize(new Dimension(20,20));
		}
		return jNumberOfDice;
	}
	private JTextField getJWField(){
		if(jWField == null){
			jWField = new JTextField("W");
			jWField.setEditable(false);
			jWField.setPreferredSize(new Dimension(20,20));
		}
		return jWField;
	}
	private JTextField getJNumberOfFaces(){
		if(jNumberOfFaces == null){
			jNumberOfFaces = new JTextField("6");
			jNumberOfFaces.setEditable(true);
			jNumberOfFaces.setPreferredSize(new Dimension(20,20));
		}
		return jNumberOfFaces;
	}
	private JTextField getJPlus(){
		if(jPlus == null){
			jPlus = new JTextField("+");
			jPlus.setEditable(false);
			jPlus.setPreferredSize(new Dimension(20,20));
		}
		return jPlus;
	}
	private JTextField getJModification(){
		if(jModification == null){
			jModification = new JTextField("0");
			jModification.setEditable(true);
			jModification.setPreferredSize(new Dimension(20,20));
		}
		return jModification;
	}
	private JTextField getJLog(){
		if(jLog == null){
			jLog = new JTextField();
			jLog.setEditable(false);
		}
		return jLog;
	}
	/***
	 * starts calculation by calling DSAKalteMain.calculate() with the given parameters.
	 * @return
	 */
	private JButton getButton(){
		if(button == null){
			button = new JButton("Rechnen");
			button.addActionListener(new ActionListener(){

				@Override
				public void actionPerformed(ActionEvent arg0) {
					DefaultTableModel model = (DefaultTableModel) getJTable().getModel();
					int[] rs = new int[main.NOOFFIGHTERS];
					for(int i=0; i<main.NOOFFIGHTERS; i++){
						try{
							rs[i] = Integer.valueOf( (String) model.getValueAt(i,1));
						}
						catch(NumberFormatException e){
							rs[i]=-1;
							getJLog().setText("Bad RS entry in Table or file.");
						}
					}
					
					int noTimes = Integer.valueOf(getJNumberOfRolls().getText());
					int noDice = Integer.valueOf(getJNumberOfDice().getText());
					int noFaces = Integer.valueOf(getJNumberOfFaces().getText());
					int mod = Integer.valueOf(getJModification().getText());
					int[] result = main.calculate(rs, noTimes, noDice, noFaces, mod);
					for(int i=0; i<main.NOOFFIGHTERS; i++){
						model.setValueAt(result[i], i,2);
					}
					getJResult().setText(noTimes+"*"+noDice+"W"+noFaces+"+"+mod);
				}
				
			});
		}
		return button;
	}
	private JTextField getJResult(){
		if(jResult == null){
			jResult = new JTextField();
			jResult.setEditable(false);
		}
		return jResult;
	}
	
	private JScrollPane getJScrollPane(){
		if(jScrollPane == null){
			jScrollPane = new JScrollPane();
			jScrollPane.add(getJTable());
			jScrollPane.setViewportView(getJTable());
			jScrollPane.setPreferredSize(new Dimension(150,80));
		}
		return jScrollPane;
	}
	private JTable getJTable(){
		if(jTable == null){
			jTable = new JTable();
			DefaultTableModel model = new DefaultTableModel();
			String[][] data = new String[main.NOOFFIGHTERS][3];
			for(int i=0; i<main.NOOFFIGHTERS; i++){
				data[i][0] = names[i];
			}
			model.setDataVector(data, new String[]{"Name","kRS","kTP(A)"});
			jTable.setModel(model);
			setTableColumnSize();
			
		}
		return jTable;
	}
	private void setTableColumnSize(){
		jTable.setAutoResizeMode(JTable.AUTO_RESIZE_LAST_COLUMN);
		jTable.getColumnModel().getColumn(0).setPreferredWidth(60);
		jTable.getColumn("kRS").setPreferredWidth(5);
		jTable.getColumn("kTP(A)").setPreferredWidth(20);
	}
	/***
	 * Bad style, but since its a very small program I was to lazy to find a better solution with Adapterclasses and so on...
	 * @param main: DSAKalteMain the Class calling initializing this Object.
	 */
	public void setMainProg(DSAKalteMain main){
		this.main = main;
	}
	
	/**
	 * Also very bad style. This is called by DSAKalteMain.readFromFile() to import Player's information.
	 * @param data
	 */
	public void setDataVector(Object[][] data){
		DefaultTableModel model = (DefaultTableModel) getJTable().getModel();
		model.setDataVector(data, new String[]{"Name","kRS","kTP(A)"});
		setTableColumnSize();
	}

}